*#cpu 8086 Tiny
*
* DDS MICRO-C Runtime library for: 8086 Family (standalone)
* TINY model!
*
* Copyright 1988-2005 Dave Dunfield
* All rights reserved.
*
	ORG	$100
*
	MOV	AX,CS		Get CODE segment
	MOV	SS,AX		Set SS
	MOV	SP,#$FFFE	Initial stack pointer
	MOV	DS,AX		Set DS
	MOV	ES,AX		Set ES
* Zero uninitialized RAM area
	MOV	DI,#?temp	Point to uninitialized RAM
	MOV	CX,#?heap+1-?temp Get size of uninitialized RAM
	XOR	AL,AL		Get a zero
	REP			Repeat prefix
	STOSB			Zero memory area
	CALL	main		Execute main program
* Exit function... Return to MSDOS
exit	XOR	AH,AH		Function 0 - exit
	INT	$21		Exit
* Compare library routines
?eq	CMP	AX,CX		CX == AX
	JZ	TRUE
	XOR	AX,AX
	RET
?ne	CMP	AX,CX		CX != AX
	JNZ	TRUE
	XOR	AX,AX
	RET
?lt	CMP	AX,CX		CX < AX
	JG	TRUE
	XOR	AX,AX
	RET
?le	CMP	AX,CX		CX <= AX
	JGE	TRUE
	XOR	AX,AX
	RET
?gt	CMP	AX,CX		CX > AX
	JL	TRUE
	XOR	AX,AX
	RET
?ge	CMP	AX,CX		CX >= AX
	JLE	TRUE
	XOR	AX,AX
	RET
?ult	CMP	AX,CX		CX < AX (unsigned)
	JA	TRUE
	XOR	AX,AX
	RET
?ule	CMP	AX,CX		CX <= AX (unsigned)
	JAE	TRUE
	XOR	AX,AX
	RET
?ugt	CMP	AX,CX		CX > AX (unsigned)
	JB	TRUE
	XOR	AX,AX
	RET
?uge	CMP	AX,CX		CX >= AX (unsigned)
	JBE	TRUE
FALSE	XOR	AX,AX
	RET
* logically negate (ax)
?not	AND	AX,AX		Test for non-zero
	JNZ	FALSE		Not zero, invert
TRUE	MOV	AX,#1		Create a true value
	AND	AX,AX		Set condition code
nargs	RET
* Handle switch statement
?switch	MOV	CX,[BX]		Get label value
	JCXZ	SWEND		End of table - Special case
	ADD	BX,#4		Skip to next
	CMP	AX,-2[BX]	Does it match?
	JNZ	?switch		No, keep looking
	JMP	CX		Execute case code
SWEND	JMP	2[BX]		Execute default code
$DD:?temp 2
